---
title: MediaTrackSettings.deviceId
slug: Web/API/MediaTrackSettings/deviceId
tags:
  - API
  - Media
  - Media Capture and Streams API
  - Media Streams API
  - MediaTrackSettings
  - Property
  - Reference
  - Settings
  - WebRTC
  - deviceId
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The {{domxref("MediaTrackSettings")}} dictionary's <code><strong>deviceId</strong></code> property is a {{domxref("DOMString")}} which uniquely identifies the source for the corresponding {{domxref("MediaStreamTrack")}} for the origin corresponding to the browsing session. This lets you determine what value was selected to comply with your specified constraints for this property's value as described in the {{domxref("MediaTrackConstraints.deviceId")}} property you provided when calling either {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}}.</p>

<p>If needed, you can determine whether or not this constraint is supported by checking the value of {{domxref("MediaTrackSupportedConstraints.deviceId")}} as returned by a call to {{domxref("MediaDevices.getSupportedConstraints()")}}. However, typically this is unnecessary since browsers will ignore any constraints they're unfamiliar with.</p>

<p>Because {{Glossary("RTP")}} doesn't include this information, tracks associated with a <a href="/en-US/docs/Web/API/WebRTC_API">WebRTC</a> {{domxref("RTCPeerConnection")}} will never include this property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>deviceId</em> = <em>MediaTrackSettings</em>.deviceId;
</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("DOMString")}} whose value is an origin-unique identifier for the track's source. This ID is valid across multiple browsing sessions for the same origin and is guaranteed to be different for all other origins, so you can safely use it to request the same source be used for multiple sessions, for example.</p>

<p>The actual value of the string, however, is determined by the source of the track, and there is no guarantee what form it will take, although the specification does recommend it be a GUID.</p>

<p>Since there is a one-to-one pairing of ID with each source, all tracks with the same source will share the same ID for any given origin, so {{domxref("MediaStreamTrack.getCapabilities()")}} will always return exactly one value for <code>deviceId</code>. That makes the device ID not useful for any changes to constraints when calling {{domxref("MediaStreamTrack.applyConstraints()")}}.</p>

<div class="note">
<p>An exception to the rule that device IDs are the same across browsing sessions: private browsing mode will use a different ID, and will change it each browsing session.</p>
</div>

<h2 id="Example">Example</h2>

<p>See {{SectionOnPage("/en-US/docs/Web/API/Media_Streams_API/Constraints", "Example: Constraint exerciser")}} for an example.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('Media Capture', '#dom-mediatracksettings-deviceid', 'deviceId') }}</td>
   <td>{{ Spec2('Media Capture') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackSettings.deviceId")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaTrackSettings.groupId")}}</li>
 <li>{{domxref("MediaTrackConstraints.deviceId")}}</li>
 <li>{{domxref("MediaTrackSettings")}}</li>
</ul>
